var ischrome = typeof chrome !== 'undefined' && typeof chrome.serial !== 'undefined';
var iswebserial = typeof navigator !== 'undefined' && typeof navigator.serial !== 'undefined';
var avr = null;
var defaultfirmwareurl = "http://unlikelyproducts.com/biolumen/firmware.latest.js";
var latestfirmware;
var firmwareversion = 0;
var hardwareversion = 0;
var uiversion = 0;
var cId = null;         // will be "dummy" for external proxy or "webserial" for webserial con
var cPath = null;
var cStream = null;
var bufjson = "";
var autodisconnector;
var statussend;
var unitstatus;
var errormessage;
var setImmediateTimeout = null;
var dragfrequency = 500;
var fw;
var bluetooth;
var sendqueue = [];
var debugcomms = 0;
var tzoff = 0;
var keys = {
    "fw1": ["latitude", "longitude", "sunrise", "sunset", "noonmin", "minlevel", "maxlevel", "duration", "solarsunrise", "solarsunset"],
    "fw2": ["latitude0", "latitude1", "longitude0", "longitude1", "simplesunrise0", "simplesunrise1", "simplesunset0", "simplesunset1", "simpleminlevel0", "simpleminlevel1", "simplemaxlevel0", "simplemaxlevel1", "dayoffset0", "dayoffset1", "minlevel0", "minlevel1", "maxlevel0", "maxlevel1", "duration0", "duration1", "solarsunrise", "solarsunset", "adjustoff", "adjustlength", "validfrom", "validto"],
    "fw3": ["latitude0", "latitude1", "longitude0", "longitude1", "simplesunrise0", "simplesunrise1", "simplesunset0", "simplesunset1", "dayoffset0", "dayoffset1", "minlevel0", "minlevel1", "simpleminlevel0", "simpleminlevel1", "simplemaxlevel0", "simplemaxlevel1", "wintermaxlevel0", "wintermaxlevel1", "summermaxlevel0", "summermaxlevel1", "winterradiation0", "winterradiation1", "summerradiation0", "summerradiation1", "duration0", "duration1", "solarsunrise", "solarsunset", "adjustoff", "adjustlength", "validfrom", "validto"],
    "fw4": ["latitude0", "latitude1", "longitude0", "longitude1", "simplesunrise0", "simplesunrise1", "simplesunset0", "simplesunset1", "dayoffset0", "dayoffset1", "minlevel0", "minlevel1", "simpleminlevel0", "simpleminlevel1", "simplemaxlevel0", "simplemaxlevel1", "wintermaxlevel0", "wintermaxlevel1", "summermaxlevel0", "summermaxlevel1", "winterradiation0", "winterradiation1", "summerradiation0", "summerradiation1", "duration0", "duration1", "solarsunrise", "solarsunset", "adjustoff", "adjustlength", "validfrom", "validto"],
    "fw5": ["latitude0", "latitude1", "longitude0", "longitude1", "simplesunrise0", "simplesunrise1", "simplesunset0", "simplesunset1", "dayoffset0", "dayoffset1", "minlevel0", "minlevel1", "simpleminlevel0", "simpleminlevel1", "simplemaxlevel0", "simplemaxlevel1", "wintermaxlevel0", "wintermaxlevel1", "summermaxlevel0", "summermaxlevel1", "winterradiation0", "winterradiation1", "summerradiation0", "summerradiation1", "duration0", "duration1", "solarsunrise", "solarsunset", "adjustoff", "adjustlength", "validfrom", "validto"],
    "fw6": ["latitude0", "latitude1", "longitude0", "longitude1", "simplesunrise0", "simplesunrise1", "simplesunset0", "simplesunset1", "dayoffset0", "dayoffset1", "minlevel0", "minlevel1", "simpleminlevel0", "simpleminlevel1", "simplemaxlevel0", "simplemaxlevel1", "wintermaxlevel0", "wintermaxlevel1", "summermaxlevel0", "summermaxlevel1", "winterradiation0", "winterradiation1", "summerradiation0", "summerradiation1", "duration0", "duration1", "solarsunrise", "solarsunset", "adjustoff", "adjustlength", "validfrom", "validto"],
    "fw7": ["latitude0", "latitude1", "longitude0", "longitude1", "simplesunrise0", "simplesunrise1", "simplesunset0", "simplesunset1", "dayoffset0", "dayoffset1", "minlevel0", "minlevel1", "simpleminlevel0", "simpleminlevel1", "simplemaxlevel0", "simplemaxlevel1", "wintermaxlevel0", "wintermaxlevel1", "summermaxlevel0", "summermaxlevel1", "winterradiation0", "winterradiation1", "summerradiation0", "summerradiation1", "duration0", "duration1", "solarsunrise", "solarsunset", "adjustoff", "adjustlength", "validfrom", "validto", "gamma"],
}
var maxfirmware = 7;

function initializeUnits() {
    var unitlist = document.getElementById("unitlist");
    while (unitlist.firstChild) {
        unitlist.removeChild(unitlist.firstChild);
    }
    unitlist.innerHTML = "<h3>Units</h3><div class='unit header'><span>Unit</span><span class='status'>Status</span><span class='level'>Level</span><span>Groups</span></div>";
}

function consoleCopy(e) {
    if (window.getSelection().type == "Range") {
        return true;
    } else {
        var consolein = document.getElementById("consolein");
        e.clipboardData.setData('text/plain', consolein.innerText);
        e.clipboardData.setData('text/html', consolein.innerHTML);
        e.preventDefault();
    }
}

function consoleAppend(line, clazz) {
    console.log(clazz+": "+line);
    if (clazz == "consoledebug") {
        var d = new Date().toISOString();
        d = d.replace(/\..*/, "");
        line = d + ": " + line;
    }
    var lines = line.toString().split(/\n/);
    for (var i=0;i<lines.length;i++) {
        var p = document.createElement("p");
        p.style.marginTop = p.style.marginBottom = "0px";
        p.style.fontFamily = "monospace";
        // Done this way so we can cut/paste styles
        if (clazz == "consoleerror") {
            p.style.color = "red";
        } else if (clazz == "consoledebug") {
            p.style.color = "#aaa";
            p.style.fontStyle = "italic";
        } else if (clazz == "consoleinput") {
            p.style.color = "black";
        } else if (clazz == "consoleoutput") {
            p.style.color = "blue";
        } else {
            p.classList.add(clazz);
        }
        p.appendChild(document.createTextNode(lines[i] + "\n"));
        var consolein = document.getElementById("consolein");
        consolein.appendChild(p);
    }
    consolein.scrollTop = consolein.scrollHeight;
    if (clazz == "consoleerror") {
        BootstrapDialog.show({
            type: BootstrapDialog.TYPE_DANGER,
            title: 'Error',
            message: errormessage,
            buttons: [{
                label: 'Close',
                action: function(dialogItself) {
                    dialogItself.close();
                }
            }]
        });
    }
}

function consoleOutput(e) {
    var echo = true;
    if (this.value == "cls") {
        var consolein = document.getElementById("consolein");
        consolein.innerHTML = "";
    } else if (this.value == "debugcomms") {
        debugcomms = 1;
    } else if (this.value == "nodebugcomms") {
        debugcomms = 0;
    } else if (/^getfirmware (.+)$/.test(this.value)) {
        var url = RegExp.$1;
        if (!/^http:/.test(url)) {
            url = "http://unlikelyproducts.com/biolumen/firmware." + url + ".js";
        }
        retrieveFirmware(url);
    } else if (/^getfirmware$/.test(this.value)) {
        retrieveFirmware(defaultfirmwareurl);
    } else if (/^reflash$/.test(this.value) && cId) {
        reflash();
    } else if (/^about$/.test(this.value)) {
        consoleAppend("* UI version: "+uiversion, "consoledebug");
        consoleAppend("* time: "+(new Date()), "consoledebug");
        consoleAppend("* utcflag: "+document.getElementById("utc").checked, "consoledebug");
        if (cId) {
            consoleAppend("* connection: "+cPath, "consoledebug");
            consoleAppend("* hardware version: "+hardwareversion, "consoledebug");
            consoleAppend("* firmware version: "+firmwareversion, "consoledebug");
            consoleAppend("* bluetooth: "+bluetooth, "consoledebug");
        } else {
            consoleAppend("* disconnected", "consoledebug");
        }
        if (ischrome) {
            var platform = window.navigator.appVersion.match(/Chrome\/(.*?) /)[1];
            chrome.runtime.getPlatformInfo(function(p) {
                consoleAppend("* platform: "+platform+"("+p.os+"/"+p.arch+")", "consoledebug");
            });
        } else {
            var platform = window.navigator.appVersion;
            consoleAppend("* platform: "+platform, "consoledebug");
        }
    } else if (/^dragupdate (\d+)$/.test(this.value)) {
        if (RegExp.$1 >= 100 && RegExp.$1 <= 2000) {
            dragfrequency = RegExp.$1;
            consoleAppend("set drag frequency to "+dragfrequency, "consoledebug");
        }
    } else if (this.value == "help") {
        consoleAppend("cls                 clear the screen", "consoledebug");
        consoleAppend("about               display UI details", "consoledebug");
        consoleAppend("debugcomms          turn comms debug on", "consoledebug");
        consoleAppend("nodebugcomms        turn comms debug off", "consoledebug");
        consoleAppend("getfirmware         get default firmware", "consoledebug");
        consoleAppend("getfirmware n       get firmware from URL n", "consoledebug");
        consoleAppend("reflash             force reflash", "consoledebug");
        consoleAppend("dragupdate n        set drag update frequence (100<=n<=2000)", "consoledebug");
    } else {
        echo = false;
        if (cId) {
            send(this.value, null);
        }
    }
    if (echo) {
        consoleAppend(this.value, "consoledebug");
    }
    this.value = "";
}

function saveGroup(checkbox) {
    var id = checkbox.id;
    if (/unit(\d+)-group(\d+)/.test(id)) {
        var unit = RegExp.$1;
        var group = RegExp.$2;
        var checked = checkbox.checked;
        if (checked) {
            send("groupadd "+unit+" "+group, null);
        } else {
            send("groupdel "+unit+" "+group, null);
        }
    }
}

function useName(ix, val) {
    document.getElementById(fw+"-name"+ix).value = val;
    var el;
    if (ix < 4) {
        el = document.querySelectorAll(".r-tabs-anchor");
        el[ix].innerHTML = val;
    } else {
        ix -= 4;
        el = document.querySelectorAll(".group"+ix+"name");
        for (var i=0;i<el.length;i++) {
            el[i].innerHTML = val;
        }
    }
}

function saveName() {
    var ix = parseInt(this.id[this.id.length-1]);
    if (this.value.length == 0) {
        this.value = ix < 4 ? "Program "+ix : "Group "+(ix-4);
    }
    var val = this.value;
    var val2 = val.replace(/[^-A-Za-z0-9 +();:,.?]/gi, "?");
    if (val != val2) {
        this.setCustomValidity("Only ASCII letters, numbers and basic punctuation");
    } else {
        this.setCustomValidity("");
        if (ix >= 0 && ix < 8) {
            if (val.length > 16) {
                val = val.substring(0, 16);
            }
            send("name "+ix+" "+val, null);
            useName(ix, val);
        }
    }
}

function setutc() {
    var mul = typeof(arguments[0]) == "number" ? arguments[0] : (document.getElementById("utc").checked ? -1 : 1);
    var n = document.querySelectorAll("."+fw+" input, ."+fw+" output");
    for (var i=0;i<n.length;i++) {
        if (/sun/.test(n[i].id)) {
//            var newval = addTimezone(n[i].value, mul);
//            console.log("id="+n[i].id+" mul="+mul+" was "+n[i].value+" now "+newval);
            n[i].value = addTimezone(n[i].value, mul);
        }
        if (/valid/.test(n[i].id)) {
            // String is always parsed as if it were UTC.
            var unixtime = Date.parse(n[i].value + "Z") + (tzoff * mul * 60000);
            n[i].value = new Date(unixtime).toISOString().replace(/Z$/,"");
        }
    }
}

function timeToMins(val) {
    if (/(\d\d):(\d\d)/.test(val)) {
        return (RegExp.$1 * 60) + (RegExp.$2 * 1);
    }
    return NaN;
}

function minsToTime(val) {
    if (val != val) {
        return "--:--";
    }
    var hr = Math.floor(val / 60);
    var out = (hr < 10 ? '0' : '') + hr + ':';
    val -= (hr*60);
    out += (val < 10 ? '0' : '') + val;
    return out;
}

function addTimezone(val, mul) {
    if (mul && /(\d\d):(\d\d)/.test(val)) {
        var time = timeToMins(val);
        time += tzoff * mul;
        if (time >= 1440) {
            time -= 1440;
        } else if (time < 0) {
            time += 1440;
        }
        val = minsToTime(time);
    }
    return val;
}

function leveldup() {
    var otherid;
    if (/simple/.test(this.id)) {
        otherid = this.id.replace(/simple/, "");
        document.getElementById(this.id.replace(/simple/, "")).value = this.value;
    } else {
        otherid = this.id.replace(/^(fw\d+)-/, "$1-simple");
    }
//    console.log("Copying "+this.id+" to "+otherid);
    document.getElementById(otherid).value = this.value;
}

function loadUnit(id, status, level, groups) {
    if (!groups || groups === "?" || groups === "[]") {
        groups = [];
    } else if (typeof(groups) == "string") {
        groups = groups.substring(1, groups.length - 1);
        groups = groups.split(/ +/);
    }
//    consoleAppend("loadUnit: id="+id+" status="+status+" level="+level+" groups="+groups, "consoledebug");
    var unitlist = document.getElementById("unitlist");
    var d = document.createElement("div");
    d.classList.add("unit");
    var x = "<span>" + id + "</span>";
    if (status == "") {
        status = "off";
    }
    x += "<span class=\"status\">" + status + "</span>";
    x += "<span class=\"level\" level=\""+level+"\">" + level + "</span>";
    d.innerHTML = x;
    for (var i=0;i<4;i++) {
        var input = document.createElement("input");
        input.type = "checkbox";
        input.id = "unit"+id+"-group"+i;
        input.name = "unit"+id+"-group";
        input.classList.add("unitgroup");
        input.addEventListener("change", function(e) {
            saveGroup(e.target);
        });
        input.value = i;
        for (var j=0;j<groups.length;j++) {
            if (groups[j]*1 === i) {
                input.checked = true;
            }
        }
        d.appendChild(input);

        var label = document.createElement("label");
        label.setAttribute("for", input.id);
        label.setAttribute("class", "group"+i+"name");
        if (fw == "fw4" || fw == "fw5" || fw == "fw6" || fw == "fw7") {
            label.innerHTML = document.getElementById(fw+"-name"+(i+4)).value;
        } else {
            label.innerHTML = "Group "+i;
        }
        d.appendChild(label);
    }
    unitlist.appendChild(d);
}

// Takes array of objects with path property
function resetDeviceList(ports) {
    var e = document.getElementById("portlist");
    while (e.firstChild) {
        e.removeChild(e.firstChild);
    }

    var addport = function(port) {
        var o = document.createElement("option");
        var path = port.path;
        if (!path) {
            path = port.id;
        }
        o.appendChild(document.createTextNode(path));
        e.appendChild(o);
        o.selected = path == cPath;
    };

    // Irritating. Chrome uses Array, Pedro gives us a Map
    if (Array.isArray(ports)) {
        for (var i=0;i<ports.length;i++) {
            addport(ports[i]);
        }
    } else {
        for (var i in ports) {
            addport(ports[i]);
        }
    }
}

function refresh() {
    consoleAppend("Refreshing", "consoledebug");
    document.getElementById("save").disabled = true;
    document.getElementById("rescan").disabled = true;
    if (iswebserial) {
        // noop
    } else if (ischrome) {
        chrome.serial.getDevices(resetDeviceList);
    } else {
        var req = new XMLHttpRequest();
        req.onreadystatechange = function(e) {
            if (req.readyState == 4) {
                if (req.status == 200) {
                    var d = JSON.parse(req.responseText)
//                    document.getElementById("version").innerHTML = "remote-" + d.version;
                    resetDeviceList(d.devices);
                } else {
                    resetDeviceList([]);
                    consoleAppend(errormessage = "Lost connection to server", "consoleerror");

                }
            }
        };
        req.open("GET", "/list");
        req.send();
    }
    if (cId) {
        initializeUnits();
        send("status\nscan", null);
    }
    setTimeout(function() {
        document.getElementById("rescan").disabled = false;
    }, cId ? 4000 : 100);
}

function initializeVersion(firmwareversion, hardwareversion, bt) {
    var nfw;
    if (firmwareversion <= 31) {
        nfw = "fw1";
    } else if (firmwareversion <= 44) {
        nfw = "fw2";
    } else if (firmwareversion <= 69) {
        nfw = "fw3";
    } else if (firmwareversion <= 81) {
        nfw = "fw4";
    } else if (firmwareversion <= 128) {
        nfw = "fw5";
    } else if (firmwareversion <= 167) {
        nfw = "fw6";
    } else {
        nfw = "fw7";
    }
    if (nfw != fw || bt != bluetooth) {
        fw = nfw;
        bluetooth = bt;
        document.getElementById("restorebutton").classList.toggle("removed", bluetooth);
        updateFlashButton();
    }
}

function receive(line) {
    consoleAppend(line, "consoleinput");

    if (/^# Autodali/.test(line)) {
        if (/^# Autodali (\d+)\/(\d+)/.test(line)) {
            initializeVersion(RegExp.$1 * 1, RegExp.$2 * 2, /^# Autodali.*0 1$/.test(line));
            refresh();
        }
        if (autodisconnector) {
            clearTimeout(autodisconnector);
            autodisconnector = null;
        }
    } else if (/^. Unit (\d+): status=\[(.*?)\] level=(\S+) groups=(.*)/.test(line)) {
        loadUnit(RegExp.$1, RegExp.$2, RegExp.$3, RegExp.$4);
    } else if (/^{"unit":/.test(line)) {
        try {
//                    line = line.replace(/"adjustoff":(\d+), "adjustlength":(\d+), "adjustloop"/, "adjustloop");       // OK without it
            var data = JSON.parse(line);
            loadUnit(data.unit, data.status, data.level, data.groups);
        } catch(e) {
            consoleAppend("Error", "consoledebug");
            consoleAppend(e.message || e, "consoleerror");
        }
    } else if (/"bank":/.test(line)) {
        var data;
        try {
            data = JSON.parse(line);
        } catch(e) {
            consoleAppend("Error", "consoledebug");
            consoleAppend(e.message || e, "consoleerror");
        }
        if (data) {
            loadData(data);
//                    loadUnit(2, "OK", 23, "[1 2]");   // DEBUG
        }
    } else if (/{"type":"servermessage/.test(line)) {
        var data;
        try {
            data = JSON.parse(line);
        } catch(e) {
            consoleAppend("Error", "consoledebug");
            consoleAppend(e.message || e, "consoleerror");
        }
        if (data) {
            if (data.error) {
                errormessage = data.error;
                consoleAppend(data.error, "consoleerror");
                disconnect(false);
            }
        }
    }
}

function send(cmd, oncomplete) {
    if (ischrome || cId == "webserial") {
        var newcall = sendqueue.length == 0;
        var lines = cmd.split(/\n/);
        if (newcall) {
            sendqueue.push(false);  // Dummy
        }
        sendqueue = sendqueue.concat(lines);
        if (oncomplete) {
            sendqueue.push(oncomplete);
        }
        if (newcall) {
            pushsend();
        }
    } else {
        var lines = cmd.split(/\n/);
        if (cmd.length > 0) {
            for (var i=0;i<lines.length;i++) {
                if (lines[i].length > 0) {
                    consoleAppend(lines[i], "consoleoutput");
                }
            }
            var req = new XMLHttpRequest();
            req.addEventListener("load", function(e) {
                if (req.readyState == 4 && req.status >= 200 && req.status <= 299) {
                    if (oncomplete) {
                        oncomplete();
                    }
                }
            });
            req.open("POST", "/write/"+cId);
            req.send(cmd);
        }
    }
}

function pushsend() {
    sendqueue.shift();   // Get rid of the previous one in the queue
    if (sendqueue.length > 0) {
        var line = sendqueue[0];
        if (typeof(line) == "string") {
            consoleAppend(line, "consoleoutput");
            var buf = new ArrayBuffer(line.length + 1);
            var bufView = new Uint8Array(buf);
            for (var i=0;i<line.length;i++) {
                bufView[i] = line.charCodeAt(i);
            }
            bufView[line.length] = 10;
            if (cId == "webserial") {
                const writer = cPath.writable.getWriter();
                writer.write(buf).then(() => {
                    if (debugcomms) {
                        consoleAppend("SENT: "+JSON.stringify(line), "consoledebug");
                    }
                    setTimeout(pushsend, 5);
                    writer.releaseLock();
                });
            } else if (cId != "dummy") {
                chrome.serial.send(cId, buf, function(x) {
                    if (debugcomms) {
                        consoleAppend("SENT: "+JSON.stringify(x), "consoledebug");
                    }
                    chrome.serial.flush(cId, function(x) {
                        if (debugcomms) {
                            consoleAppend("FLUSH", "consoledebug");
                        }
                        // Artificially rate-limit - max one line per 5ms. Enough for c. 25chars at 57600
                        setTimeout(pushsend, 5);
                    });
                });
            } else {
                pushsend();
            }
        } else {
            line();
            pushsend();
        }
    }
}

function dirtyvalidate() {
    document.getElementById("save").classList.add("btn-danger");
    validate();
}

function considerImmediateValueChanges() {
//    var valid = !document.getElementById("save").disabled;
    var valid = cId;
    if (valid && (fw == "fw4" || fw == "fw5" || fw == "fw6" || fw == "fw7")) {
        for (var i=0;i<4;i++) {
            var mode = form.elements["mode-"+i].value;
            if (mode == "nc") {
                var oldvalue = document.getElementById(fw+"-value-output-"+i).value;
                var newvalue = document.getElementById(fw+"-value-"+i).value;
                if (oldvalue != newvalue) {
                    document.getElementById(fw+"-value-output-"+i).value = newvalue;
                    if (newvalue == 1 || newvalue == 2) {
                        newvalue = 3;
                    }
                    var target = form.elements["target-"+i].value;
                    if (target == 'u') {
                        target += document.getElementById("targetunit-"+i).value;
                    }
                    var out = "";
                    if (fw == "fw5" || fw == "fw6" || fw == "fw7") {
                         out = "bank "+i+"\n";
                         if (unitstatus.bank[i].target != target) {
                             out += "target "+target+"\n";
                             unitstatus.bank[i].target = target;
                         }
                         out += "nc"+newvalue;
                    } else {
                        var x = newvalue == 255 ? 0x0105 : newvalue == 0 ? 0x0100 : newvalue & 0xFF; // maxlevel/off/value
                        if (target == 'all') {
                            x |= 0xFE00;
                        } else if (target[0] == 'u') {
                            x |= (((target[1]-'0')&0x3F)<< 9);
                        } else if (target[0] == 'g') {
                            x |= 0x8000 | (((target[1]-'0')&0xF)<< 9);
                        } else {
                            return;
                        }
                        x = x.toString(16).toUpperCase();
                        while (x.length < 4) {
                            x = "0" + x;
                        }
                        out += x;
                    }
                    send(out, null);
                }
            }
        }
    }
}

function validate() {
    document.getElementById("backupbutton").style.display = (cId == null ? "none" : "inline-block");
    document.getElementById("restorebuttonlabel").style.display = (cId == null ? "none" : "inline-block");
    var n = document.querySelectorAll("#form input");
    for (var i=0;i<n.length;i++) {
        n[i].disabled = cId == null;
    }
    for (var j=1;j<=maxfirmware;j++) {
        var n = document.querySelectorAll(".fw"+j);
        for (var i=0;i<n.length;i++) {
            n[i].classList.toggle("removed", fw != "fw"+j);
        }
        var n = document.querySelectorAll(".fw"+j+" input");
        for (var i=0;i<n.length;i++) {
            n[i].disabled = fw != "fw"+j;
        }
        var n = document.querySelectorAll(".fw"+j+" input:not([type='checkbox'])");
        for (var i=0;i<n.length;i++) {
            if (!n[i].classList.contains("notrequired")) {
                n[i].required = fw == "fw"+j;
                n[i].disabled = fw != "fw"+j;
            }
        }
    }

    var form = document.forms[0];
    var isutc = document.getElementById("utc").checked;
    for (var i=0;i<4;i++) {
        var mode = form.elements["mode-"+i].value;
        var target = form.elements["target-"+i].value;
        document.getElementById("targetunit-"+i).disabled = target != 'u';
        document.getElementById(fw+"-fieldset-solar-"+i).disabled = mode != 'solar';
        document.getElementById(fw+"-fieldset-simple-"+i).disabled = mode != 'simple';
        if (fw == "fw7") {
            document.getElementById(fw+"-gamma-output-"+i).value = parseFloat(127.0 / document.getElementById(fw+"-gamma-"+i).value).toFixed(3);
        }
        if (fw == "fw4" || fw == "fw5" || fw == "fw6" || fw == "fw7") {
            document.getElementById(fw+"-fieldset-nc-"+i).disabled = mode != 'nc';
        }
        if (fw == "fw2" || fw == "fw3" || fw == "fw4" || fw == "fw5" || fw == "fw6" || fw == "fw7") {
            document.getElementById(fw+"-adjustoff-"+i).max = document.getElementById(fw+"-adjustlength-"+i).value;
            document.getElementById(fw+"-adjustoff-"+i).value = Math.min(document.getElementById(fw+"-adjustoff-"+i).value,document.getElementById(fw+"-adjustoff-"+i).max),
            document.getElementById(fw+"-adjustoff-output-"+i).value = document.getElementById(fw+"-adjustoff-"+i).value;
            var t1 = document.getElementById(fw+"-adjustlength-"+i).value * 1;
            var n = document.querySelectorAll("."+fw+" input");
            for (var j=0;j<n.length;j++) {
                if (new RegExp(fw+"-.*?1-"+i).test(n[j].id)) {
                    n[j].disabled = t1 == 0;
                }
            }

            // Calculate the winter/summer radiation from the winter/summer level
            if (fw == "fw3" || fw == "fw4" || fw == "fw5" || fw == "fw6" || fw == "fw7") {
                var winterradiation0 = getRadiation(document.getElementById(fw+"-latitude0-"+i).value, dimmestMinute(document.getElementById(fw+"-latitude0-"+i).value)).radiation;
                var winterradiation1 = getRadiation(document.getElementById(fw+"-latitude1-"+i).value, dimmestMinute(document.getElementById(fw+"-latitude1-"+i).value)).radiation;
                var summerradiation0 = getRadiation(document.getElementById(fw+"-latitude0-"+i).value, brightestMinute(document.getElementById(fw+"-latitude0-"+i).value)).radiation;
                var summerradiation1 = getRadiation(document.getElementById(fw+"-latitude1-"+i).value, brightestMinute(document.getElementById(fw+"-latitude1-"+i).value)).radiation;
                document.getElementById(fw+"-winterradiation0-"+i).value = winterradiation0;
                document.getElementById(fw+"-winterradiation1-"+i).value = winterradiation1;
                document.getElementById(fw+"-summerradiation0-"+i).value = summerradiation0;
                document.getElementById(fw+"-summerradiation1-"+i).value = summerradiation1;
            }

            var latitude, longitude, dayoffset, minlevel, wintermaxlevel, summermaxlevel, winterradiation, summerradiation;

            var t = t1 == 0 ? 0 : document.getElementById(fw+"-adjustoff-"+i).value / t1;
            var n = document.querySelectorAll("#tab-"+i+" ."+fw+" output.intermediate");
            if (t1 == 0) {
                for (var j=0;j<n.length;j++) {
                    n[j].value = "";
                }
                for (var j=0;j<keys[fw].length;j++) {
                    if (/0$/.test(keys[fw][j])) {
                        var key = keys[fw][j].replace(/0$/, "");
                        var id0 = fw+"-"+key+"0-"+i;
                        var id1 = fw+"-"+key+"1-"+i;
                        if (document.getElementById(id0) && document.getElementById(id1)) {
                            document.getElementById(id1).value = document.getElementById(id0).value;
                        }
                    }
                }
                latitude = document.getElementById(fw+"-latitude0-"+i).value * 1;
                longitude = document.getElementById(fw+"-longitude0-"+i).value * 1;
                dayoffset = document.getElementById(fw+"-dayoffset0-"+i).value * 1;
                minlevel = document.getElementById(fw+"-minlevel0-"+i).value * 1;
                if (fw == "fw3" || fw == "fw4" || fw == "fw5" || fw == "fw6" || fw == "fw7") {
                    wintermaxlevel = document.getElementById(fw+"-wintermaxlevel0-"+i).value * 1;
                    summermaxlevel = document.getElementById(fw+"-summermaxlevel0-"+i).value * 1;
                    winterradiation = document.getElementById(fw+"-winterradiation0-"+i).value * 1;
                    summerradiation = document.getElementById(fw+"-summerradiation0-"+i).value * 1;
                } else {
                    wintermaxlevel = summermaxlevel = document.getElementById(fw+"-maxlevel0-"+i).value * 1;
                }
            } else {
                for (var j=0;j<n.length;j++) {
                    var id = n[j].id;
                    var val0 = document.getElementById(id.replace(/-intermediate/, "0")).value;
                    var val1 = document.getElementById(id.replace(/-intermediate/, "1")).value;
                    var timeval = /simplesun/.test(id);
                    if (timeval) {
                        val0 = timeToMins(val0);
                        val1 = timeToMins(val1);
                        if (val0 - val1 > 1440/2) {
                            val1 += 1440;
                        }
                        if (val1 - val0 > 1440/2) {
                            val0 += 1440;
                        }
                    }
                    var val = Math.round(val0*1 + ((val1*1)-(val0*1)) * t);
                    if (timeval) {
                        if (val < 0) {
                            val += 1440;
                        }
                        if (val >= 1440) {
                            val -= 1440;
                        }
                        val = minsToTime(val);
                    }
                    n[j].value = val;
                }
                latitude = document.getElementById(fw+"-latitude-intermediate-"+i).value * 1;
                longitude = document.getElementById(fw+"-longitude-intermediate-"+i).value * 1;
                dayoffset = document.getElementById(fw+"-dayoffset-intermediate-"+i).value * 1;
                minlevel = document.getElementById(fw+"-minlevel-intermediate-"+i).value * 1;
                if (fw == "fw3" || fw == "fw4" || fw == "fw5" || fw == "fw6" || fw == "fw7") {
                    wintermaxlevel = document.getElementById(fw+"-wintermaxlevel-intermediate-"+i).value * 1;
                    summermaxlevel = document.getElementById(fw+"-summermaxlevel-intermediate-"+i).value * 1;
                    winterradiation = document.getElementById(fw+"-winterradiation-intermediate-"+i).value * 1;
                    summerradiation = document.getElementById(fw+"-summerradiation-intermediate-"+i).value * 1;
                } else {
                    wintermaxlevel = summermaxlevel = document.getElementById(fw+"-maxlevel-intermediate-"+i).value * 1;
                }
            }

            var radiationnow = getRadiation(latitude, getMinuteOfYear(Date.now() + dayoffset*86400000), longitude*4);
            if (document.getElementById(fw+"-radiation-"+i)) {
                document.getElementById(fw+"-radiation-"+i).value = radiationnow.radiation + " W/m²";
            }
            if (document.getElementById(fw+"-noonradiation-"+i)) {
                document.getElementById(fw+"-noonradiation-"+i).value = radiationnow.noonradiation + " W/m²";
            }
            if (document.getElementById(fw+"-solarsunrise-"+i)) {
                if (!isutc) {
                    radiationnow.sunrise = (radiationnow.sunrise + tzoff + 1440) % 1440;
                    radiationnow.sunset = (radiationnow.sunset + tzoff + 1440) % 1440;
                }
                document.getElementById(fw+"-solarsunrise-"+i).value = minsToTime(radiationnow.sunrise);
                document.getElementById(fw+"-solarsunset-"+i).value = minsToTime(radiationnow.sunset);
            }
            if (fw == "fw3" || fw == "fw4" || fw == "fw5" || fw == "fw6" || fw == "fw7") {
                var tt = (radiationnow.noonradiation - winterradiation) / (summerradiation - winterradiation);
                var maxlevel = Math.round(wintermaxlevel + tt * (summermaxlevel-wintermaxlevel));
                tt = radiationnow.radiation / radiationnow.noonradiation;
                var level = Math.round(minlevel + tt * (maxlevel - minlevel));
                if (document.getElementById(fw+"-noonlevel-"+i)) {
                    document.getElementById(fw+"-noonlevel-"+i).value = maxlevel;
                }
                if (document.getElementById(fw+"-level-"+i)) {
                    document.getElementById(fw+"-level-"+i).value = level;
                }
            }

            var dateoptions = {};
            if (isutc) {
                dateoptions.timeZone = "UTC";
            }
            document.getElementById(fw+"-todaysdate-"+i).value = new Intl.DateTimeFormat("ca-iso8601", dateoptions).format(new Date());
            document.getElementById(fw+"-programdate-"+i).value = new Intl.DateTimeFormat("ca-iso8601", dateoptions).format(new Date(Date.now() + dayoffset * 86400000));

        } else {
            var lat = document.getElementById(fw+"-latitude-"+i).value;
            var lon = document.getElementById(fw+"-longitude-"+i).value;
            var minuteofyear = getMinuteOfYear(Date.now());
            var x = getRadiation(lat, minuteofyear, lon*4);
            if (!isutc) {
                x.sunrise = (x.sunrise + tzoff + 1440) % 1440;
                x.sunset = (x.sunset + tzoff + 1440) % 1440;
            }
            document.getElementById(fw+"-solarsunrise-"+i).value = minsToTime(x.sunrise);
            document.getElementById(fw+"-solarsunset-"+i).value = minsToTime(x.sunset);
        }
    }
    for (var i=0;i<form.elements.length;i++) {
        var f = form.elements[i];
        if (f.required && f.validationMessage) {
            consoleAppend("Field \""+f.id+"\" value \""+f.value+"\" invalid: "+f.validationMessage , "consoledebug");
        }
    }
    document.getElementById("save").disabled = !form.checkValidity() || !cId;
}

function testsave() {
    if (fw == "fw2" || fw == "fw3" || fw == "fw4" || fw == "fw5" || fw == "fw6" || fw == "fw7") {
        for (var i=0;i<4;i++) {
            var mode = document.forms[0].elements["mode-"+i].value;
            var adjustlength = document.getElementById(fw+"-adjustlength-"+i).value * 1;
            if (mode == "solar" && adjustlength != 0) {
                var posdrift = document.getElementById(fw+"-latitude0-"+i).value != document.getElementById(fw+"-latitude1-"+i).value || document.getElementById(fw+"-longitude0-"+i).value != document.getElementById(fw+"-longitude1-"+i).value;
                var daydrift = document.getElementById(fw+"-dayoffset0-"+i).value != document.getElementById(fw+"-dayoffset1-"+i).value;
                var mindrift = document.getElementById(fw+"-minlevel0-"+i).value != document.getElementById(fw+"-minlevel1-"+i).value;
                var maxdrift;
                if (fw == "fw3" || fw == "fw4" || fw == "fw5" || fw == "fw6" || fw == "fw7") {
                    var maxdrift = document.getElementById(fw+"-wintermaxlevel0-"+i).value != document.getElementById(fw+"-wintermaxlevel1-"+i).value || document.getElementById(fw+"-summermaxlevel0-"+i).value != document.getElementById(fw+"-summermaxlevel1-"+i).value;
                } else {
                    var maxdrift = document.getElementById(fw+"-maxlevel0-"+i).value != document.getElementById(fw+"-maxlevel1-"+i).value;
                }

//                console.log(posdrift+" "+daydrift+" "+mindrift+" "+maxdrift);
                if (posdrift && (daydrift || mindrift || maxdrift)) {
                    $('#responsiveTabs').responsiveTabs('activate', i);
                    BootstrapDialog.confirm("You are modifying both the latitude/longitude AND one of the other settings on this program. Typically you would modify only one of these. Are you sure you want to save?", function(r) {
                        if (r) {
                            save();
                        }
                    });
                    return;
                }
            }
        }
    }
    save();
}

function save() {
    consoleAppend("Saving", "consoledebug");
    document.getElementById("save").innerHTML = '<span class="glyphicon glyphicon-refresh glyphicon-refresh-animate"></span> Saving...';
    document.getElementById("rescan").disabled = true;
    document.getElementById("save").disabled = true;
    document.getElementById("save").classList.remove("btn-danger");
    var cmds = "";
    var form = document.forms[0];
    for (var i=0;i<4;i++) {
        cmds += "bank "+ i + "\n";
        var bank = unitstatus.bank[i];
        var mode = form.elements["mode-"+i].value;
        if ((fw == "fw5" || fw == "fw6" || fw == "fw7") && mode == "nc") {
            var slidervalue = document.getElementById(fw+"-value-"+i).value;
            if (slidervalue == 1 || slidervalue == 2) {
                slidervalue = 3;
            }
            mode = "nc"+slidervalue;
        }
        if (mode != bank.mode && mode != "nc"+bank.mode) {
            cmds += mode + "\n";
        }

        var target = form.elements["target-"+i].value;
        if (target == 'u') {
            target += form.elements["targetunit-"+i].value;
        }
        if (target != bank.target) {
            cmds += "target " + target + "\n";
        }
        if (fw == "fw6") {
            if (tzoff != bank.tzoff) {
                cmds += "tzoff " + tzoff + "\n";
            }
            var dow = 0;
            for (var j=0;j<7;j++) {
                if (form.elements[fw+"-dow-"+i][j].checked) {
                    dow |= (1<<j);
                }
            }
            if (dow != bank.dow) {
                cmds += "dow " + dow + "\n";
            }
        }

        if (!document.getElementById("utc").checked) {
            setutc(-1);
        }
        for (var j=0;j<keys[fw].length;j++) {
            var key = keys[fw][j];
            var elt = form.elements[fw+"-"+key+"-"+i];
            if (elt instanceof HTMLInputElement || elt instanceof HTMLOutputElement) {
                var val = elt.value;
                if (/valid/.test(key)) {
                    val = val.replace(/\.\d+$/, "");
                }
                if (bank[key] != val) {
                    if (/valid/.test(key)) {
                        val = Date.parse(val + "Z") / 1000;   // in UTC
                    }
                    var skip = 0;
                    if (fw == "fw2") {
                        skip = /simple(min|max)/.test(key) || /solarsun/.test(key);
                    } else if (fw == "fw3" || fw == "fw4" || fw == "fw5" || fw == "fw6" || fw == "fw7") {
                        skip = /simplemin/.test(key) || /solarsun/.test(key);
                    } else if (fw == "fw1") {
                        key = key.replace(/^solar/, "");
                    }
                    if (!skip) {
                        cmds += key + " " + val + "\n";
                    }
                }
            }
        }
        if (!document.getElementById("utc").checked) {
            setutc(1);
        }
    }
    send(cmds, refresh);
}

function connect(port) {
    if (cId != null) {
        disconnect(false);
    } else if (iswebserial) {
        navigator.serial.requestPort().then((port) => {
            port.open({baudRate:57600}).then(() => {
                cId = "webserial";
                cPath = port;
                document.getElementById("connect").classList.add("btn-danger");
                document.getElementById("connect").innerHTML = "Disconnect";
                consoleAppend("Connected to port "+port+" cid="+cId, "consoledebug");
                port.abortController = new AbortController();
                cReader = port.readable.pipeThrough(new TextDecoderStream()).pipeTo(new WritableStream({
                    write(chunk) {
                        if (!cPath) {
                            console.log("here!");
                            cancel();
                        } else {
                            bufjson += chunk.replace(/\r/, "");
                            var ix;
                            while ((ix = bufjson.indexOf("\n")) >= 0) {
                                receive(bufjson.substring(0, ix));
                                bufjson = bufjson.substring(ix + 1);
                            }
                        }
                    },
                    abort(x, controller) {
                        console.log("receive abort: "+JSON.stringify(x));
                        console.log(controller);
                    },
                    close(x) {
                        console.log("receive close: "+JSON.stringify(x));
                        if (cId && x.connectionId == cId) {
                            disconnect();
                        }
                    }
                }), { signal: port.abortController.signal }).catch(() => {
                    // This is where the abort has been called to disconnect.
                    cReader = null;
                    disconnect();
                });
            });
        });
    } else {
        if (typeof(port) !== "string") {
            var e = document.getElementById("portlist");
            port = e.options[e.selectedIndex].value;
        }
        document.getElementById("connect").disabled = true;
        if (ischrome) {
            chrome.serial.connect(port, { }, function(ci) {
                document.getElementById("connect").disabled = false;
                if (chrome.runtime.lastError) {
                    var e = chrome.runtime.lastError;
                    console.log(e.message);
                    errormessage = e.message;
                    consoleAppend("Error connecting to "+port, "consoledebug");
                    consoleAppend(e.message || e, "consoleerror");
                } else if (ci) {
                    cId = ci.connectionId;
                    cPath = port;
                    flush();
                    document.getElementById("connect").classList.add("btn-danger");
                    document.getElementById("connect").innerHTML = "Disconnect";
                    consoleAppend("Connected to port "+port+" cid="+cId, "consoledebug");
                    autodisconnector = setTimeout(function() {
                        disconnect(true);
                    }, 2000);
                }
            });
        } else {
            cStream = new EventSource("/read/"+port);
            document.getElementById("connect").disabled = false;
            cStream.onopen = function() {
                cId = port;
                cPath = port;
                flush();
                document.getElementById("connect").classList.add("btn-danger");
                document.getElementById("connect").innerHTML = "Disconnect";
                consoleAppend("Connected to port "+port, "consoledebug");
                setTimeout(function() {
                    send("status", null);
                }, 500);
            };
            cStream.onmessage = function(e) {
                if (e.data.length > 0) {
                    receive(e.data);
                }
            };
            cStream.addEventListener("connection", function(e) {
                if (e.data.length > 0) {
                    receive(e.data);
                }
            });
            cStream.onerror = function(e) {
                disconnect(true);
            };
        }
    }
}

function flush() {
    if (cId == "webserial") {
        // This isn't called for webserial
    } else if (ischrome && cId && cId != "dummy") {
        chrome.serial.flush(cId, function() {});
    }
}

function disconnect(auto) {
    if (cId == "webserial") {
        // This doesn't really work properly, connection is still open.
        // Webserial is a fucking disaster. Have to cancel reader, then
        // wait, then close, but can't seem to get this working with the
        // pipeTo approach. So below does not close the path! Need to reload 
        if (cReader != null) {
            cPath.abortController.abort();
        } else {
            cPath.close();
        }
    } else if (cId && cId != "dummy") {
        flush();
        if (ischrome) {
            chrome.serial.disconnect(cId, function () {
                if (auto) {
                    consoleAppend("Disconnect (auto)", "consoledebug");
                } else {
                    consoleAppend("Disconnect", "consoledebug");
                }
            });
        } else {
            consoleAppend("Disconnect", "consoledebug");
            cStream.close();
            cStream = null;
        }
    }
    cId = null;
    cPath = null;
    cStream = null;
    firmwareversion = hardwareversion = null;
    document.getElementById("connect").classList.remove("btn-danger");
    document.getElementById("connect").innerHTML = "Connect";
    document.getElementById("save").disabled = true;
    var n = document.querySelectorAll("#form input");
    for (var i=0;i<n.length;i++) {
        if (n[i].type == "checkbox" || n[i].type == "radio") {
            n[i].checked = false;
        } else {
            n[i].value = "";
        }
        n[i].disabled = true;
    }
    initializeUnits();
    updateFlashButton();
}

function loadData(data) {
    //Defaulting inputs
    unitstatus = data;
    var form = document.forms[0];
    if (data.utctime) {
        var hardwaretime = Date.parse(data.utctime + "Z");
        if (Math.abs(hardwaretime - Date.now()) > 10000) {
            send("settime "+Math.floor(new Date().getTime() / 1000), null);
        }
    }
    if (data.fw && data.hw) {
        initializeVersion(data.fw, data.hw, data.bt);
    }
    for (var i=0;i<data.bank.length;i++) {
        var bank = data.bank[i];
        var id = bank.id;
        var modeval = parseInt(bank.mode);
        if (fw == "fw5" || fw == "fw6" || fw == "fw7") {
            if (modeval == modeval) {
                form.elements["mode-"+id].value = "nc";
                form.elements[fw+"-value-"+id].value = modeval;
            } else {
                form.elements["mode-"+id].value = bank.mode;
                form.elements[fw+"-value-"+id].value = 0;
            }
        } else {
            form.elements["mode-"+id].value = bank.mode;
        }
        var target = bank.target;
        if (target[0] == 'u') {
            form.elements["targetunit-"+id].value = target.substr(1);
            target = "u";
        }
        form.elements["target-"+id].value = target;

        var mul = document.getElementById("utc").checked ? 0 : -1;
        for (var j=0;j<keys[fw].length;j++) {
            var key = keys[fw][j];
            var elt = form.elements[fw+"-"+key+"-"+id];
            if (elt && typeof bank[key] !== "undefined") {
                var value = bank[key];
                elt.value = value;
            }
        }
        if (fw == "fw2") {
            document.getElementById(fw+"-simpleminlevel0-"+id).value = document.getElementById(fw+"-minlevel0-"+id).value;
            document.getElementById(fw+"-simpleminlevel1-"+id).value = document.getElementById(fw+"-minlevel1-"+id).value;
            document.getElementById(fw+"-simplemaxlevel0-"+id).value = document.getElementById(fw+"-maxlevel0-"+id).value;
            document.getElementById(fw+"-simplemaxlevel1-"+id).value = document.getElementById(fw+"-maxlevel1-"+id).value;
        } else if (fw == "fw3" || fw == "fw4" || fw == "fw5" || fw == "fw6" || fw == "fw7") {
            document.getElementById(fw+"-simpleminlevel0-"+id).value = document.getElementById(fw+"-minlevel0-"+id).value;
            document.getElementById(fw+"-simpleminlevel1-"+id).value = document.getElementById(fw+"-minlevel1-"+id).value;
        }
        if (fw == "fw4" || fw == "fw5" || fw == "fw6" || fw == "fw7") {
            form.elements[fw+"-value-output-"+id].value = form.elements[fw+"-value-"+id].value;
        }
        if (fw == "fw6") {
            for (var j=0;j<7;j++) {
                form.elements[fw+"-dow-"+id][j].checked = bank.dow & (1<<j);
            }
        }
    }
    if (fw == "fw4" || fw == "fw5" || fw == "fw6" || fw == "fw7") {
        for (var i=0;i<data.name.length;i++) {
            useName(i, data.name[i]);
        }
    }

    if (!document.getElementById("utc").checked) {
        setutc();
    }
    document.getElementById("save").innerHTML = '<span class="glyphicon glyphicon-floppy-save" aria-hidden="true"></span> Save';
    document.getElementById("save").disabled = false;
    document.getElementById("rescan").disabled = false;
    document.getElementById("save").classList.remove("btn-danger");
    validate();
}

var statusJSON = null;
var sending = false;


// Interprets an ArrayBuffer as UTF-8 encoded string data.
var ab2str = function(buf) {
    return new TextDecoder("utf-8").decode(buf);
};

document.addEventListener("DOMContentLoaded", function() {

    tzoff = new Date().getTimezoneOffset() * -1;
    fw = "fw1";
    if (iswebserial) {
        // Have to choose serial port with a different mechanism
        document.getElementById("portlist").parentNode.style.display = "none";
    }
    refresh();
    if (ischrome) {
        if (!iswebserial) {
            chrome.serial.onReceive.addListener(function(info) {
                if (info.data && info.connectionId == cId) {
                    bufjson += ab2str(info.data).replace(/\r/, "");
                    var ix;
                    while ((ix = bufjson.indexOf("\n")) >= 0) {
                        receive(bufjson.substring(0, ix));
                        bufjson = bufjson.substring(ix + 1);
                    }
                }
            });
            chrome.serial.onReceiveError.addListener(function(x) {
                console.log("receive error: "+JSON.stringify(x));
                if (cId && x.connectionId == cId) {
                    disconnect();
                }
            });
        }
        uiversion = chrome.runtime.getManifest().version;
        document.getElementById("version").innerHTML = uiversion;
    } else {
        var req = new XMLHttpRequest();
        req.addEventListener("load", function(e) {
            if (req.readyState == req.DONE && req.status == 200) {
                var manifest = JSON.parse(req.responseText);
                uiversion = manifest.version;
                document.getElementById("version").innerHTML = "remote-"+uiversion;
            }
        });
        req.open("GET", "/manifest.json");
        req.send();
    }
    document.getElementById("connect").addEventListener("click", connect);
    document.getElementById("save").addEventListener("click", testsave);
    document.getElementById("rescan").addEventListener("click", refresh);
    document.getElementById("consoleout").addEventListener("change", consoleOutput);
    document.addEventListener('copy', consoleCopy);
    document.getElementById("utc").addEventListener("change", setutc);
    disconnect();
    if (ischrome) {
        chrome.runtime.getPlatformInfo(function(p) {
            var version = window.navigator.appVersion.match(/Chrome\/(.*?) /)[1];
            consoleAppend("Started UI version "+chrome.runtime.getManifest().version+" on "+version+"("+p.os+"/"+p.arch+")", "consoledebug");
            if (p.os == "mac") {
                var n = document.getElementById("consolenote");
                n.innerHTML = "Type &#8984;C to copy contents of the console to the clipboard";
                errormessage = "&#8984;C";
            } else {
                errormessage = "Ctrl-C";
            }
            errormessage = "Something unexpected happened. Please do the following to report this error:<br/><br/><ol><li>Type "+errormessage+" to copy the error to your clipboard</li><li>Paste this into an email and send it to your customer support contact</li></ol>";
        });
    }

    // Clone fields
    //
    var tab0 = document.getElementById("tab-0").innerHTML
    for (var i=1; i<4; i++) {
        document.getElementById("tab-"+i).innerHTML = tab0.replace(/data-bank="0"/gi, "data-bank=\""+i+"\"").replace(/-0/gi, "-"+i);
    }

    // Add Event Listeners after clone
    //
    var el = document.querySelectorAll("input");
    for (var i=0;i<el.length;i++) {
        var method = dirtyvalidate;
        if (el[i].id == "utc") {
            method = validate;
        } else if (/fw.-name\d/.test(el[i].id)) {
            method = saveName;
        } else if (/console/.test(el[i].id)) {
            method = null;
        }
        if (method) {
            el[i].addEventListener("change", method);
            if (el[i].type == "range") {
                el[i].addEventListener("input", method);
            }
        }
    }

    var dupfields = [ "fw2-minlevel", "fw2-simpleminlevel", "fw2-maxlevel", "fw2-simplemaxlevel", "fw3-minlevel", "fw3-simpleminlevel", "fw4-minlevel", "fw4-simpleminlevel", "fw5-minlevel", "fw5-simpleminlevel", "fw6-minlevel", "fw6-simpleminlevel", "fw7-minlevel", "fw7-simpleminlevel" ];
    for (var i=0;i<dupfields.length;i++) {
        for (var j=0;j<4;j++) {
            document.getElementById(dupfields[i]+"0-"+j).addEventListener("input", leveldup);
            document.getElementById(dupfields[i]+"0-"+j).addEventListener("change", leveldup);
            document.getElementById(dupfields[i]+"1-"+j).addEventListener("input", leveldup);
            document.getElementById(dupfields[i]+"1-"+j).addEventListener("change", leveldup);
        }
    }
    document.getElementById("backupbutton").addEventListener("click", backup);
    document.getElementById("restorebutton").addEventListener("change", function() {
        var reader = new FileReader();
        var file = this.files[0];
        reader.onload = function() {
            restore(file.name, reader.result);
        };          
        reader.readAsText(file, "UTF-8");
    });

    document.getElementById("flashbutton").addEventListener("click", reflash);

    $('#responsiveTabs').responsiveTabs({
        startCollapsed: 'false',
        active: 0
    });
    $('#responsiveTabs').responsiveTabs('activate', 0);
    var el = document.querySelectorAll("#r-tabs-anchor");
    for (var i=0;i<el.length;i++) {
        el[i].addEventListener("dblclick", tabDoubleClick);
    }
    validate();

    setInterval(considerImmediateValueChanges, dragfrequency);
    if (ischrome) {
        retrieveFirmware(defaultfirmwareurl);
    }
}, false);

//----------------------- from firmware

/**
 * Return the sun's declination for the specified solar day in degrees
 * @param day the day of the year (0..365);
 */
function declination(dayofyear) {
    return 23.45 * Math.sin((360.0 / 365.0 * (dayofyear-81)) * Math.PI / 180);
}

/**
 * Given a latitude in the tropics, return the minute of the year with the brightest sunlight
 * The day with the dimmest sunlight will still be the winter solstice for that
 * half of the equator (north or south, or either if it's on the equator)
 */
function brightestMinute(latitude) {
    latitude = Math.max(-1, Math.min(1, latitude / 23.45));
    return Math.round(((Math.PI - Math.asin(latitude)) * 180 / Math.PI * 365 / 360) + 81.5) * 1440 + 720;
}

function dimmestMinute(latitude) {
    return latitude < 0 ? brightestMinute(90) : brightestMinute(-90);
}

/**
 * Note this is using a simplified solar model from
 * http://pveducation.org/pvcdrom/properties-of-sunlight/calculation-of-solar-insolation
 * rather than the classic algorithm as used in solartime() above. This is because we
 * care about the solar insolation rather than the exact time of civil sunrise.
 *
 * @param latitude the latitude in degrees
 * @param minuteofyear the minute of the year at the nominal longitude
 *
 * @return an object with the values {sunrise, sunset, radiation, noonradiaion} where sunrise/sunset
 * are specified in minutes since midnight UTC, and radiation/noonradtion are the solar irradiance now 
 * and at noon in W/m2
 */
function getRadiation(latitude, minuteofyear, minuteoffset) {
    minuteoffset = typeof minuteoffset !== 'undefined' ? minuteoffset : 0;
    minuteofyear += minuteoffset;
    var dayofyear = Math.floor(minuteofyear / 1440);
    var minuteofday = minuteofyear - (dayofyear * 1440);

    var dec = declination(dayofyear) * Math.PI / 180;
    var lat = latitude * Math.PI / 180;
    var halfdaylength = 4 * Math.acos((0 - Math.sin(dec) * Math.sin(lat)) / (Math.cos(dec) * Math.cos(lat))) * 180 / Math.PI;
    if (halfdaylength > 720) {
        halfdaylength = 720;
    } else if (halfdaylength < 0) {
        halfdaylength = 0;
    }
    var sunrise = (Math.floor(720 - halfdaylength) - minuteoffset + 2880) % 1440;
    var sunset = (Math.floor(720 + halfdaylength) - minuteoffset + 2880) % 1440;
    var noonradiation = getIrradiance(getSolarZenith(720, dec, lat));
    var radiation = getIrradiance(getSolarZenith(minuteofday, dec, lat));
//    console.log("getRadiation("+latitude+","+(minuteofyear-minuteoffset)+","+minuteoffset+") = "+sunrise+"/"+sunset+"/"+radiation+" mod="+minuteofday);
    return { sunrise: sunrise, sunset: sunset, radiation: radiation, noonradiation: noonradiation };
}

function isLeapYear(year) {
    return (((1970+year)>0) && !((1970+year)%4) && ( ((1970+year)%100) || !((1970+year)%400) ))
}

/**
 * @param off the offset to the current time in milliseconds
 * @return the minute of the current year.
 */
function getMinuteOfYear(now) {
    var date = new Date(now);
    date.setUTCSeconds(0);
    date.setUTCMinutes(0);
    date.setUTCHours(0);
    date.setUTCMonth(0);
    date.setUTCDate(1);
    return (now - date.getTime()) / 60000;
}


/**
 * @param minuteofday minute since midnight
 * @param declination suns declination in radians
 * @param latitude latitude in radians
 * @return solar zenith in radians
 */ 
function getSolarZenith(minuteofday, dec, lat) {
    var hra = (minuteofday - 720) * 0.25 * Math.PI / 180;
    var zenith = Math.acos(Math.sin(dec) * Math.sin(lat) + Math.cos(dec) * Math.cos(lat) * Math.cos(hra));
    return Math.min(zenith, Math.PI / 2);
}

/**
 * Calculate the solar irradiance in W/m2.
 * Uses Adnot(1979) as it's simple and includes diffuse
 * @param zenith the solar zenith in radians
 */
function getIrradiance(zenith) {
    return Math.round(951.39 * Math.pow(Math.cos(zenith), 1.15));
}

function backup() {
    var isutc = document.getElementById("utc").checked;
    setutc(-1);
    var data = {};
    data.fw = fw;
    data.bank = [{}, {}, {}, {}];
    var form = document.forms[0];
    for (var i=0;i<4;i++) {
        var target = form.elements["target-"+i].value;
        if (target == 'u') {
            target += form.elements["targetunit-"+i].value;
        }
        data.bank[i].id = i;
        data.bank[i].target = target;
        data.bank[i].mode = form.elements["mode-"+i].value;
        if ((fw == "fw5" || fw == "fw6" || fw == "fw7") && data.bank[i].mode == "nc") {
            data.bank[i].mode = document.getElementById(fw+"-value-"+i).value;
        }
        for (var j=0;j<keys[fw].length;j++) {
            var key = keys[fw][j];
            var elt = form.elements[fw+"-"+key+"-"+i];
            if (elt instanceof HTMLInputElement) {
                var val = elt.value;
                if (/valid/.test(key) && val) {
                    val = new Date(val).toISOString().replace(/\..*/, "");
                }
                data.bank[i][key] = val;
            }
        }
        if (fw == "fw6") {
            val = 0;
            for (var j=0;j<7;j++) {
                if (form.elements[fw+"-dow-"+i][j].checked) {
                    val |= (1<<j);
                }
            }
            data.bank[i].dow = val;
        }
    }
    setutc(isutc ? 1 : -1);
    if (fw == "fw4" || fw == "fw5" || fw == "fw6" || fw == "fw7") {
        data.name = [];
        for (var i=0;i<8;i++) {
            data.name[i] = document.getElementById(fw+"-name"+i).value;
        }
    }
    data.units = {};
    for (var i=0;i<63;i++) {
        for (var j=0;j<4;j++) {
            var elt = document.getElementById("unit"+i+"-group"+j);
            if (elt) {
                var flag = data.units[i];
                if (typeof(flag) == "undefined") {
                    flag = 0;
                }
                if (elt.checked) {
                    flag |= (1<<j);
                }
                data.units[i] = flag;
            }
        }
    }
    console.log(data);

    if (ischrome) {
        chrome.fileSystem.chooseEntry({type:"saveFile",suggestedName:"biolumen.bak"}, function(entry) {
            entry.createWriter(function(writer) {
                writer.onerror = function(e) {
                    console.log("Error1: "+e);
                };
                var blob = new Blob([JSON.stringify(data)], {type: "text/plain"});
                writer.onwriteend = function(e) {
                    writer.onwriteend = null;
                    this.truncate(this.position);
                    BootstrapDialog.alert("Saved backup to "+entry.name);
                };
                writer.write(blob);
            }, function(e) { console.log("Error2: "+e); });
        });
    } else {
        var link = document.createElement('a');
        link.download = "biolumen.bak";;
        link.href = "data:application/octet-stream," + encodeURIComponent(JSON.stringify(data));
        document.body.appendChild(link);
        link.click();
        document.body.removeChild(link);
    }
}

function restore(filename, text) {
    var form = document.forms[0];
    try {
        data = JSON.parse(text);
        if (data.fw == "fw2" && (fw == "fw3" || fw == "fw4" || fw == "fw5" || fw == "fw6" || fw == "fw7")) {
            for (var i=0;i<4;i++) {
                data.bank[i].summermaxlevel0 = data.bank[i].wintermaxlevel0 = data.bank[i].maxlevel0;
                data.bank[i].summermaxlevel1 = data.bank[i].wintermaxlevel1 = data.bank[i].maxlevel1;
            }
            data.fw = "fw3";
        }
        if (data.fw == "fw3" && (fw == "fw4" || fw == "fw5" || fw == "fw6" || fw == "fw7")) {
            for (var i=0;i<4;i++) {
                if (/^(on|off|fadeon|fadeoff|flash|cycle)$/.test(data.bank[i].mode)) {
                    data.bank[i].mode = "nc";
                }
            }
            data.fw = "fw4";
        }
        if (data.fw == "fw4" && fw == "fw5") {
            data.fw = "fw5";
        }
        if (data.fw == "fw5" && fw == "fw6") {
            for (var i=0;i<4;i++) {
                data[i].dow = 127;
                data[i].tzoff = 0;
            }
            data.fw = "fw6";
        }
        if ((data.fw == "fw5" || data.fw == "fw6") && fw == "fw7") {
            delete data[i].dow;
            delete data[i].tzoff;
            data[i].gamma = 127;
        }
         
        if (data.fw == fw) {
            consoleAppend("Loading backup from "+filename, "consoledebug");
            console.log(data);
            var x = unitstatus;
            var oldnames = [];
            for (var i=0;i<8;i++) {
                var elt = document.getElementById(fw+"-name"+i);
                if (elt) {
                    oldnames[i] = elt.value;
                }
            }
            loadData(data);
            for (var i=0;i<8;i++) {
                var elt = document.getElementById(fw+"-name"+i);
                if (elt && elt.value != oldnames[i]) {
                    saveName.call(elt);
                }
            }

            unitstatus = x;
            var cmd = "";
            for (var i=0;i<63;i++) {
                for (var j=0;j<4;j++) {
                    var elt = document.getElementById("unit"+i+"-group"+j);
                    if (elt) {
                        var flag = data.units[i];
                        if (typeof(flag) == "undefined") {
                            flag = 0;
                        }
                        if (elt.checked && !(flag & (1<<j))) {
                            elt.checked = false;
                            cmd += "groupdel "+i+" "+j+"\n";
                        } else if (!elt.checked && (flag & (1<<j))) {
                            elt.checked = true;
                            cmd += "groupadd "+i+" "+j+"\n";
                        }
                    }
                }
            }
            if (cmd) {
                send(cmd, save);
            } else {
                save();
            }
            BootstrapDialog.alert("Loaded backup from "+filename+" and saved to device");
        } else {
            throw "Backup is from firmware '"+data.fw+"', can't restore to firmware '"+fw+"'";
        }
    } catch(e) {
        errormessage = e.message;
        console.log(e);
        consoleAppend("Error", "consoledebug");
        consoleAppend(e.message || e, "consoleerror");
    }
}

function retrieveFirmware(firmwareurl) {
    latestfirmware = {};
    var req = new XMLHttpRequest();
    req.addEventListener("load", function(e) {
        if (req.readyState == req.DONE && req.status == 200) {
            latestfirmware = JSON.parse(req.responseText);
            req = new XMLHttpRequest();
            for (var hw in latestfirmware.url) {
                req.addEventListener("load", function(e) {
                    if (req.readyState == req.DONE && req.status == 200) {
                        /* intel_hex.parse(data)
                                `data` - Intel Hex file (string in ASCII format or Buffer Object)
                                `bufferSize` - the size of the Buffer containing the data (optional)
                                
                                returns an Object with the following properties:
                                        - data - data as a Buffer Object, padded with 0xFF
                                                where data is empty.
                                        - startSegmentAddress - the address provided by the last
                                                start segment address record; null, if not given
                                        - startLinearAddress - the address provided by the last
                                                start linear address record; null, if not given
                                Special thanks to: http://en.wikipedia.org/wiki/Intel_HEX
                        */
                        function parseIntelHex(data, bufferSize) {
                            const DATA = 0, EOF = 1;
                            //Initialization
                            var buf = [];
                            var bufLength = 0; //Length of data in the buffer
                            var highAddress = 0; //upper address
                            var startSegmentAddress = null;
                            var startLinearAddress = null;
                            var lineNum = 0; //Line number in the Intel Hex string
                            var pos = 0; //Current position in the Intel Hex string
                            var expectedLowAddress = 0;
                            while (pos + 11 <= data.length) {
                                //Parse an entire line
                                if (data.charAt(pos++) != ":") {
                                    throw new Error("Line " + (lineNum+1) + " does not start with a colon (:).");
                                } else {
                                    lineNum++;
                                }
                                var dataLength = parseInt(data.substr(pos, 2), 16); //Number of bytes (hex digit pairs) in the data field
                                pos += 2;
                                var lowAddress = parseInt(data.substr(pos, 4), 16); //Get 16-bit address (big-endian)
                                pos += 4;
                                var recordType = parseInt(data.substr(pos, 2), 16); //Record type
                                pos += 2;
                                var linebytes = [];
                                for (var i=0;i<dataLength;i++) {
                                    linebytes.push(parseInt(data.substr(pos, 2), 16));      // Data field (hex-encoded string)
                                    pos += 2;
                                }
                                var checksum = parseInt(data.substr(pos, 2), 16);
                                //Checksum
                                pos += 2;
                                //Validate checksum
                                var calcChecksum = (linebytes.length + (lowAddress >> 8) + lowAddress + recordType) & 0xFF;
                                for (var i = 0; i < linebytes.length; i++) {
                                    calcChecksum = (calcChecksum + linebytes[i]) & 0xFF;
                                }
                                calcChecksum = (0x100 - calcChecksum) & 0xFF;
                                if (checksum != calcChecksum) {
                                    throw new Error("Invalid checksum on line " + lineNum + ": got " + checksum + ", but expected " + calcChecksum);
                                }
                                if (recordType == DATA) {
                                    if (lowAddress != expectedLowAddress) {
                                        throw new Error("address "+lowAddress+" not "+expectedLowAddress);
                                    }
                                    buf = buf.concat(linebytes);

                                    expectedLowAddress += linebytes.length;
                                } else if (recordType == EOF) {
                                    if (linebytes.length != 0) {
                                        throw new Error("EOF has data");
                                    }
                                    return buf;
                                } else {
                                    throw new Error("Unknown record type "+recordType+" parsing firmware");
                                }
                                if (data.charAt(pos) == "\r") {
                                    pos++;
                                }
                                if (data.charAt(pos) == "\n") {
                                    pos++;
                                }
                            }
                            console.log("Unexpected EOF loading firmare");
                        }
                        if (!latestfirmware.hex) {
                            latestfirmware.hex = {};
                        }
                        latestfirmware.hex[hw] = parseIntelHex(req.responseText);
                        
                        consoleAppend("Downloaded firmware "+latestfirmware.version+" for hardware "+hw+": "+latestfirmware.hex[hw].length+" bytes", "consoledebug");
                        updateFlashButton();
                    }
                });
                req.open("GET", latestfirmware.url[hw]);
                req.send();
            }
        }
    });
    req.open("GET", firmwareurl+"?"+Math.random());
    req.send();
}

function updateFlashButton() {
    document.getElementById("flashbutton").classList.toggle("removed", !ischrome || !cId || bluetooth || !latestfirmware.hex || !latestfirmware.hex[hardwareversion] || (firmwareversion >= latestfirmware.version && !latestfirmware.force));
}

function reflash() {
    BootstrapDialog.confirm("You are about to reflash your firmware from "+firmwareversion+" to "+latestfirmware.version+". This is a theoretically risky operation and may render your controller inoperable if something goes wrong.\n\nIf you click OK, the controller will disconnect and be reflashed. Details on the process will be logged to the console; once complete, we will attempt to reconnect to the device. The process takes about 5 seconds.\n\nAll settings wil be lost, so you should do a backup before reflashing and a restore afterwards.\n\nAre you sure you want to do this now?", function(r) {
        if (r) {
            var devices = {};
            var avrpath;
            chrome.serial.getDevices(function(ports) {
                for (var i=0;i<ports.length;i++) {
                    if (ports[i].path != cPath) {
                        devices[ports[i].path] = "old";
                    }
                }
            });
            send("\nbootloader");

            var searchtime = 5000;
            var searchinterval = 100;
            var hexfile = latestfirmware.hex[hardwareversion];
            setTimeout(function() {
                var searchcount = 50;
                function finder() {
                    chrome.serial.getDevices(function(ports) {
                        var pathfound = false;
                        for (var i=0;i<ports.length;i++) {
                            pathfound |= ports[i].path == cPath;
                            if (!devices[ports[i].path] && ports[i].path != cPath) {
                                avrpath = ports[i].path;
                            }
                        }
                        if (!pathfound && cId) {
                            disconnect();
                        } else if (!avrpath || cId) {
                            searchtime -= searchinterval;
                            if (searchtime > 0) {
                                setTimeout(finder, searchinterval);
                            }
                        } else {
                            consoleAppend("Found new serial on "+avrpath, "consoledebug");
                            setTimeout(function() {
                                chrome.serial.connect(avrpath, { }, function(ci) {
                                    if (chrome.runtime.lastError) {
                                        var e = chrome.runtime.lastError;
                                        consoleAppend(e.message || e, "consoleerror");
                                    } else if (ci) {
                                        avr = {};
                                        avr.cid = ci.connectionId;
                                        avr.cmd = null;
                                        avr.cmds = [];
                                        avr.bytes = hexfile;
                                        function avrReceive(info) {
                                            if (info.data && info.connectionId == avr.cid) {
                                                var data = new DataView(info.data);
                                                data.toString = function() {
                                                    return new TextDecoder("iso-8859-1").decode(this.buffer);
                                                };
//                                                    console.log("## Recv "+data.toString());
                                                avr.cmd && avr.cmd.callback(data);
                                                avr.next();
                                            }
                                        }
                                        chrome.serial.onReceive.addListener(avrReceive);

                                        avr.c = function(value, fn) {
                                            avr.cmds.push({value: value, callback: function(data) {
                                                fn && fn(data);
                                            }});
                                            return avr;
                                        }
                                        avr.next = function() {
                                            avr.cmd = avr.cmds.shift();
                                            if (avr.cmd) {
                                                var val = [];
                                                if (typeof(avr.cmd.value) == "string") {
                                                    avr.cmd.value = [ avr.cmd.value ];
                                                }
                                                for (var i=0;i<avr.cmd.value.length;i++) {
                                                    if (typeof(avr.cmd.value[i]) == 'string') {
                                                        for (var j=0;j<avr.cmd.value[i].length;j++) {
                                                            val.push(avr.cmd.value[i].charCodeAt(j));
                                                        }
                                                    } else {
                                                        val.push(avr.cmd.value[i]);
                                                    }
                                                }
    //                                            console.log("## Send "+val);
                                                var buf = new ArrayBuffer(val.length);
                                                var bufView = new Uint8Array(buf);
                                                for (var i=0;i<val.length;i++) {
                                                    bufView[i] = val[i];
                                                }
                                                chrome.serial.send(avr.cid, buf, function() {});
                                            }
                                        };

                                        avr.close = function() {
                                            chrome.serial.onReceive.removeListener(avrReceive);
                                            chrome.serial.disconnect(avr.cid, function () {
                                            });
                                            avr.cid = null;
                                            avr.cmd = null;
                                            avr.cmds = [];
                                        };

                                        // Prepare
                                        avr.c('S', function(d) {
                                            if (d.toString() !== "LUFACDC") {
                                                var msg = "Invalid signature, expecting LUFACDC, got "+d.toString();
                                                console.log(msg);
                                                consoleAppend(msg, "consoleerror");
                                                avr.close();
                                            }
                                        })
                                        .c('V')
                                        .c('v')
                                        .c('p')
                                        .c('a')
                                        .c('b', function(d) {
                                            avr.flashChunkSize = d.getUint8(2);
    //                                        console.log("Flash chunk size="+avr.flashChunkSize);
                                        })
                                        .c('t')
                                        .c('TD')
                                        .c('P')
                                        .c('F')
                                        .c('F')
                                        .c('F')
                                        .c('N')
                                        .c('N')
                                        .c('N')
                                        .c('Q')
                                        .c('Q')
                                        .c('Q')
                                        .c(['A', 0x03, 0xfc])
                                        .c(['g', 0x00, 0x01, 'E'])
                                        .c(['A', 0x03, 0xff])
                                        .c(['g', 0x00, 0x01, 'E'])
                                        .c(['A', 0x03, 0xff])
                                        .c(['g', 0x00, 0x01, 'E'])
                                        .c(['A', 0x03, 0xff])
                                        .c(['g', 0x00, 0x01, 'E'], function() {
                                            consoleAppend("Erasing Flash", "consoledebug");
                                        });

                                        // Erase
                                        avr.c('e', function() {
                                            consoleAppend("Programming "+avr.bytes.length+" bytes in chunks of "+avr.flashChunkSize, "consoledebug");
                                        });

                                        // Program
                                        avr.c(['A', 0x00, 0x00], function() {
                                            avr.chunksSent = [];
                                            console.log("chunklist = "+avr.bytes.length+" "+avr.flashChunkSize);
                                            for (var i=0; i<avr.bytes.length; i+=avr.flashChunkSize) {
                                                var chunk = Array.prototype.slice.call(avr.bytes.slice(i, i + avr.flashChunkSize));
                                                avr.chunksSent.push(chunk);
                                                avr.c(['B', 0x00, chunk.length, 'F'].concat(chunk), function() {
                                                });
                                            }
                                            // Fusecheck
                                            avr.c('F', function() {
                                                consoleAppend("Chunks sent, checking fuses", "consoledebug");
                                            })
                                            .c('F')
                                            .c('F')
                                            .c('N')
                                            .c('N')
                                            .c('N')
                                            .c('Q')
                                            .c('Q')
                                            .c('Q')
                                            .c('L')
                                            .c('E', function() {
                                                consoleAppend("Flash complete. Reconnect and confirm firmware version is "+latestfirmware.version, "consoledebug");
                                                avr.close();

                                                avrpath = null;
                                                searchtime = 1000;
                                                searchinterval = 100;
                                                function finder() {
                                                    chrome.serial.getDevices(function(ports) {
                                                        for (var i=0;i<ports.length;i++) {
                                                            if (!devices[ports[i].path]) {
                                                                avrpath = ports[i].path;
                                                            }
                                                        }
                                                        if (!avrpath) {
                                                            searchtime -= searchinterval;
                                                            if (searchtime > 0) {
                                                                setTimeout(finder, searchinterval);
                                                            }
                                                        } else {
                                                            refresh();
                                                            consoleAppend("Reconnecting to "+avrpath, "consoledebug");
                                                            setTimeout(function() {
                                                                connect(avrpath);
                                                                setTimeout(function() {
                                                                    if (cId && firmwareversion == latestfirmware.version) {
                                                                        BootstrapDialog.alert("Everyting worked and you are on firmware "+firmwareversion+". You may now exhale.");
                                                                    } else if (cId) {
                                                                        BootstrapDialog.alert("Reflash failed, but you still have a functioning device on the old firmware "+firmwareversion);
                                                                    } else if (cId) {
                                                                        BootstrapDialog.alert("Unable to reconnect to device. Try reconnecting manually");
                                                                    }
                                                                }, 500);
                                                            }, 1000);
                                                        }
                                                    });
                                                }
                                                finder();
                                            });
                                        });

                                        avr.next();
                                    }
                                });
                            }, 200);
                        }
                    });
                }
                finder();
            }, 200);
        }
    });
}
